/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSCommandLineAPIHost_h
#define JSCommandLineAPIHost_h

#include "CommandLineAPIHost.h"
#include "JSDOMWrapper.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSCommandLineAPIHost : public JSDOMWrapper<CommandLineAPIHost> {
public:
    typedef JSDOMWrapper<CommandLineAPIHost> Base;
    static JSCommandLineAPIHost* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<CommandLineAPIHost>&& impl)
    {
        JSCommandLineAPIHost* ptr = new (NotNull, JSC::allocateCell<JSCommandLineAPIHost>(globalObject->vm().heap)) JSCommandLineAPIHost(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static const bool hasStaticPropertyTable = false;

    static JSC::JSObject* createPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static JSC::JSObject* getPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static CommandLineAPIHost* toWrapped(JSC::JSValue);
    static void destroy(JSC::JSCell*);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }


    // Custom functions
    JSC::JSValue inspect(JSC::ExecState&);
    JSC::JSValue inspectedObject(JSC::ExecState&);
    JSC::JSValue getEventListeners(JSC::ExecState&);
    JSC::JSValue databaseId(JSC::ExecState&);
    JSC::JSValue storageId(JSC::ExecState&);
protected:
    JSCommandLineAPIHost(JSC::Structure*, JSDOMGlobalObject&, Ref<CommandLineAPIHost>&&);

    void finishCreation(JSC::VM& vm)
    {
        Base::finishCreation(vm);
        ASSERT(inherits(info()));
    }

};

class JSCommandLineAPIHostOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, CommandLineAPIHost*)
{
    static NeverDestroyed<JSCommandLineAPIHostOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(CommandLineAPIHost* wrappableObject)
{
    return wrappableObject;
}

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, CommandLineAPIHost*);
inline JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, CommandLineAPIHost& impl) { return toJS(state, globalObject, &impl); }
JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject*, CommandLineAPIHost*);


} // namespace WebCore

#endif
