/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSFontFaceSet_h
#define JSFontFaceSet_h

#include "FontFaceSet.h"
#include "JSEventTarget.h"

namespace WebCore {

class JSFontFaceSet : public JSEventTarget {
public:
    typedef JSEventTarget Base;
    static JSFontFaceSet* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<FontFaceSet>&& impl)
    {
        JSFontFaceSet* ptr = new (NotNull, JSC::allocateCell<JSFontFaceSet>(globalObject->vm().heap)) JSFontFaceSet(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static const bool hasStaticPropertyTable = false;

    static JSC::JSObject* createPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static JSC::JSObject* getPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static FontFaceSet* toWrapped(JSC::JSValue);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    static void visitChildren(JSCell*, JSC::SlotVisitor&);


    // Custom attributes
    JSC::JSValue ready(JSC::ExecState&) const;

    // Custom functions
    JSC::JSValue entries(JSC::ExecState&);
    JSC::JSValue keys(JSC::ExecState&);
    JSC::JSValue values(JSC::ExecState&);
    FontFaceSet& wrapped() const
    {
        return static_cast<FontFaceSet&>(Base::wrapped());
    }
protected:
    JSFontFaceSet(JSC::Structure*, JSDOMGlobalObject&, Ref<FontFaceSet>&&);

    void finishCreation(JSC::VM& vm)
    {
        Base::finishCreation(vm);
        ASSERT(inherits(info()));
    }

};

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, FontFaceSet*);
inline JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, FontFaceSet& impl) { return toJS(state, globalObject, &impl); }
JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject*, FontFaceSet*);


} // namespace WebCore

#endif
